//+------------------------------------------------------------------+
//|                                         Pivot Moving Average.mq4 |
//|                                                             Pooh |
//|                                                               NA |
//+------------------------------------------------------------------+
#property copyright "Pooh"
#property link      "NA"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 DarkGray
#property indicator_color3 PaleVioletRed
#property indicator_color4 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_width4 2


//--- input parameters

extern int    Period_1   = 20;
extern int    Count      = 100;
extern int    MA_Period  = 10;
extern bool   Sample     = false;
extern double Deviations = 2;




//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);  SetIndexLabel(0,"Upper Band");
   SetIndexBuffer(1,ExtMapBuffer2);  SetIndexLabel(1,"Average");
   SetIndexBuffer(2,ExtMapBuffer3);  SetIndexLabel(2,"Lower Band");
   SetIndexBuffer(3,ExtMapBuffer4);  SetIndexLabel(3,"Ocean Number");
   
   string short_name = "Ocean";
   IndicatorShortName(short_name);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
  
   for(int i=limit; i>=0; i--)
   {
      //
      //
      //    
      //
      //
      if (Bars-i>Period_1)         
            ExtMapBuffer4[i]=(MathLog(iClose(NULL,0,i))-MathLog(iClose(NULL,0,i+Period_1)))/MathSqrt(Period_1);
      else  ExtMapBuffer4[i]=0;
   }
   for(i=limit; i>=0; i--)
   {
      double deviation = iDeviation(ExtMapBuffer4[i],MA_Period,Sample,i);
      ExtMapBuffer2[i] = iMAOnArray(ExtMapBuffer4,0,MA_Period,0,MODE_SMA,i);
      ExtMapBuffer1[i] = ExtMapBuffer2[i]+deviation*Deviations;
      ExtMapBuffer3[i] = ExtMapBuffer2[i]-deviation*Deviations;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

double workDev[];
double iDeviation(double value, int length, bool isSample, int i)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); i=Bars-i-1; 
                 workDev[i] = value;
                 double sumx=0,sumxx=0; for (int k=0; k<length && k<=i; sumx+=workDev[i-k],sumxx+=workDev[i-k]*workDev[i-k],k++) {}
   return(MathSqrt((sumxx-sumx*sumx/length)/MathMax(length-isSample,1)));
}